
## About
This project is an example C code for V by F control of a 3-phase induction motor, using TI's IQmath library. The code has been implemented to work on LAUNCHXL-F28069M.

## Steps for running the code
1. Clone this project inside a CCS workspace
   1. Open a terminal in the CCS workspace folder
   2. run `git clone https://gitlab.com/opelexnet/software/code/C2000/VbyF_IQmath_vars.git`
2. Open the workspace in CCS
3. Import the project into CCS workspace, without copying it
   1. Select Menu `Project > Import CCS Projects`
   2. Press the `Browse` button for `Select search-directory`
   3. Then browse to the Workspace and press OK
   4. Make sure you tick the project you just cloned
   5. Do not check either `Automatically import referenced projects found in same directory` or `Copy projects into workspace`
   6. Press the Finish button
4. If not already defined, add `C2000WARE_ROOT` path variable to the workspace
   1. Select Menu `Window > Preferences`
   2. Select option `General > Workspace > Linked Resources`
   3. Press the `New` button for `Defined path variables`
   4. Enter Name as `C2000WARE_ROOT`
   5. Enter Location as full path to the C2000Ware version folder
   6. Press OK button in the two windows
5. Build and Debug (`F11`) the program
   1. Before running, make sure that the variable `freq_set` is set to a safe value

## Description of Files
### Source/Header files
#### Files in this folder
| File              | Description                                    |
|:------------------|:-----------------------------------------------|
| functions.h       | prototypes of all functions                    |
| GlobalVariables.h | global variable declarations                   |
| macros.h          | macro definitions (#define)                    |
| SysCtrl.h         | header file for SysCtrl.c                      |
| Epwm.c            | epwm initialization                            |
| GlobalVariables.c | global variable definition and initialization  |
| Gpio.c            | GPIO initialization                            |
| ISRs.c            | interrupt service rountines                    |
| Interrupt.c       | interrupt initialization                       |
| Interrupt2.c      | alternate interrupt initialization (not used)  |
| main.c            | file with main function                        |
| SysCtrl.c         | system initialization (adapted from C2000Ware) |

#### Files linked from C2000Ware
| File                        | Description                                    |
|:----------------------------|:-----------------------------------------------|
| F2806x_usDelay.asm          | Assembly file for software delay in us         |
| F2806x_GlobalVariableDefs.c | C2000 Peripheral register definitions          |
| F2806x_Headers_nonBIOS.cmd  | Linker command file for peripheral registers   |

### CCS Linker/Target files
| File                             | Description                               |
|:---------------------------------|:------------------------------------------|
| f28069M_ram_lnk.cmd              | linker command file (from C2000Ware)      |
| targetConfigs/TMS320F28069.ccxml | target configuration (CCS autogenerated)  |

### CCS/Eclipse settings
| File        | Description           |
|:------------|:----------------------|
| .project    | Project settings      |
| .cproject   | Eclipse settings      |
| .ccsproject | CCS specific settings |

## License
All files which are taken/adapted from C2000Ware are copyrighted by Texas Instruments Incorporated. The LICENSE information of these files can be found at the top of each file.

All other files are made available under MIT License, which can be read from the LICENSE file in this folder.
